/**	PointersToFunctionsExample1.cpp
*
* C++ allows operations with pointers to functions. 
* The typical use of this is for passing a function as an argument to another 
* function, since these cannot be passed dereferenced. In order to declare a pointer 
* to a function we have to declare it like the prototype of the function except that 
* the name of the function is enclosed between parentheses () and an asterisk (*) is 
* inserted before the name:
**/

#include <iostream>
using namespace std;

int addition (int a, int b){ 
	return (a + b); 
}

int subtraction (int a, int b){ 
	return (a - b); 
}

int operation (int x, int y, int (*funcTocall)(int,int)){
  //int g;
  //g = (*funcTocall)(x,y);
  int g = (*funcTocall)(x,y);	
  return g;
}

int main ()
{
    int m,n;
    int (*minus)(int,int) = subtraction;
    // int (*minus)(int,int);
	// minus = subtraction;

// ο int (*minus)(int,int) είναι δεικτης σε 
										 // συνάρτηση με ορίσματα (int,int)
    									 // και που επιστρέφει int. Αρχικοποίηση με την
										// διεύθυνση της συνάρτησης subtraction.

 	//int (*minus)(int,int) = &subtraction // ίδιο με το από πάνω 	
    m = operation (7, 5, addition);
    n = operation (20, m, minus);
    //cout << "m = " << m << ", n = " << n << endl;
    cout << "operation(7, 5, addition) = " << m << endl
    	 << "operation(20, operation(7, 5, addition), minus) = " << n << endl;
    return 0;   
}

// In the example, minus is a pointer to a function that has two parameters of type int. 
// It is immediately assigned to point to the function subtraction, all in a single line:
