/*
multipleInheritance.cpp

Multiple Inheritance

In C++ it is perfectly possible that a class inherits members from more than one class. This is done by simply
separating the different base classes with commas in the derived class declaration.
*/

#include <iostream>
using namespace std;

class CPolygon {
      protected:
             int width, height;
      public:
             void set_values (int a, int b)
             { 
                  width = a; 
                  height = b;
             }
};

class COutput {
      public:
             void output (float i) 
			{
				cout << "area= " << i << endl;
			}
};

class CRectangle: public CPolygon, public COutput {
      public:
             float area ()
             { 
                 return (width * height); 
             }
};

class CTriangle: public CPolygon, public COutput {
      public:
             float area ()
             { 
                 return (width * height / 2.0); 
             }
};

int main () {
    CRectangle rect;
    CTriangle trgl;

    rect.set_values (3,5);
    trgl.set_values (3,5);
    rect.output (rect.area());
    trgl.output (trgl.area());

    return (0);       
}
