// Circle.hpp
using namespace std;

#ifndef _Circle_hpp_
#define _Circle_hpp_
#include <cmath>

#define pi acos(-1.0)

class Circle{
      private:
              double center_x;
              double center_y;
              double radius;      
      public:
             Circle()
             {
                	center_x = 0;
                	center_y = 0;
                        radius=0;                                         
             }

             Circle (double x, double y, double r)
             {
                    if (r < 0.0) 
                    {
                       cout << " Error: Negative radius\n";
                       center_x = 0;
                       center_y = 0;
                       radius   = 0;
                    }
                    else
                    {
                       center_x = x;
                       center_y = y;
                       radius   = r;
                    }
             }
             
			~Circle() {};

             void set(double x, double y, double r)
             {
                    center_x = x;
                    center_y = y;
                    radius   = r;
             }
             
             // copy constructor
             Circle copy(Circle c)
             {
                    center_x = c.center_x; // this->center_x = c.center_x;
                    center_y = c.center_y; // this->center_y = c.center_y;
                    radius   = c.radius;   // this->radius   = c.radius;
                    
                    return (*this);
             }
             
             // if circle1 = circle2, circle1 gets the values of circle2
             Circle operator= (Circle c)
             {
                    center_x = c.center_x;
                    center_y = c.center_y;
                    radius   = c.radius;
                    
                    return (*this);
             }

             // defining the equality of circles
             bool operator== (Circle c)
             {
                    return (center_x == c.center_x &&
                            center_y == c.center_y &&
                            radius   == c.radius);
             }
             
             double area()
             {
                    return (pi*radius*radius);
             }
                     
             void printc()
             {
                    cout << " Center: (x,y) = ";
                    cout << "(" << center_x << "," << center_y << ")";
                    cout << " radius = " << radius << endl;
             }
};

#endif
